%archana gupta
%hw 7   
%image processing -principal component analysis

%to run program at command line type 'pca(comp_no)' 
%where comp_no is no of principal components used for calculations

function pcarec=pca(imdat,comp_no)
imdat=double(imdat);
%gives columnvector and their corresponding coordinates
[vect,coord]=imstack2vectors(imdat);
imageno=size(imdat,3);

%find principal component
P=princomp(vect,comp_no);

%calculate euclidean distance between principal component images
%P.A contains the principal component transformation matrix (ix12)
%i is no of principal components
PCmat=P.A;
edist=[];

for i=1:imageno
    for j=1:imageno
        edist(i,j) = norm(PCmat(:,i)-PCmat(:,j));
    end
end


%reconstruct original image
for j=1:imageno
    h1=P.X(:,j);
    h1=reshape(h1,size(imdat,1),size(imdat,2));
    figure;
    imshow(h1,[]);    
end

%calculate euclidean distance between actual and reconstructed image
%P.X contains the reconstructed vectors 

recvect=P.X;
edist1=[];

for i=1:imageno
    for j=1:imageno
        edist1(i,j) = norm(vect(:,i)-recvect(:,j));
    end
end

pcarec=reshape(recvect,size(imdat,1),size(imdat,2),size(imdat,3));

return;
